#include<stdlib.h>
#include<stdio.h>
#include<errno.h>
#include<sys/mman.h>
#include<signal.h>
#include"debug.h"
#include"pmseg.h"

PMSeg* PMSeg::wurzel=NULL;

const unsigned long PAGESIZE=4096;
static EnvDebug debug("pmseg","pmseg");

static void sigseg(int sig,siginfo_t *siginfo, void *unkown)
{
  debug.message(2,"SEGV catched:\n");
  char *p = (char *)((long)(siginfo->si_addr)&~(PAGESIZE-1)); 
  debug.message(2,"Error at ptr=%p page=%p ",siginfo->si_addr,p);
  switch(siginfo->si_code)
  {
  case SEGV_MAPERR: debug.message(2,"address not mapped to object\n");
                    break;
  case SEGV_ACCERR: debug.message(2,"invalid permissions for mapped object\n");
                    break;
  default:
    debug.message(2,"unknown\n");
  }
  if(siginfo->si_code == SEGV_ACCERR)
  {
    PMSeg *seg;
    if((seg=PMSeg::lookup(siginfo->si_addr))!=NULL)
    {
      debug.message(2,"Hebe Sperrung auf\n");
      seg->handle(p,siginfo->si_addr);
      int r=mprotect(p,4096,PROT_READ|PROT_WRITE);
      if(r<0) 
      {
	perror("mprotect");exit(errno);
      }
      return;
    }
  }
  debug.message(2,"Anderer SEGV ...\n");
  struct sigaction sa;
  sa.sa_flags=0;
  sigemptyset(&(sa.sa_mask));
  sa.sa_handler = SIG_DFL;
  sigaction(SIGSEGV,&sa,NULL);
}

void PMSeg::insert(PMSeg *diese)
{
  if(wurzel==NULL)
  {
    debug.message(2,"Initialisiere Signalhandler \n");
    struct sigaction sa;
    sa.sa_flags = SA_SIGINFO|SA_RESTART;
    sigemptyset(&(sa.sa_mask));
    sa.sa_sigaction = sigseg;
    sigaction(SIGSEGV,&sa,NULL);
  }
  PMSeg **akt = &wurzel;
  while((*akt)!=NULL && (*akt)->begin() < diese->begin())
  {
    akt=&((*akt)->next);
  }
  diese->next=*akt;
  *akt = diese;
}

void PMSeg::remove(PMSeg *diese)
{
  PMSeg **akt = &wurzel;
  while((*akt)!=NULL && (*akt)->begin() < diese->begin())
  {
    akt=&((*akt)->next);
  }
  if(*akt==diese)
  {
    *akt=(*akt)->next;
  }
}

PMSeg *PMSeg::lookup(void *addr)
{
  PMSeg *akt=wurzel;
  while( akt!= NULL && akt->begin() <=  addr  )
  {
    if(akt->begin() <= addr && addr <= (char *)(akt->end()))
    {
      return akt;
    }
    akt = akt->next;
  }
  return NULL;
}

PMSeg::PMSeg(char *anfang,size_t len): RAMS::Mseg(anfang,len)
{
  insert(this);
}

void PMSeg::set(char *anfang,size_t lang)
{
  setto(anfang,lang);
  insert(this);
}

PMSeg::~PMSeg()
{
  remove(this);
}
